<?php
/*
Plugin Name: Easy Typography
Description: Easy Typography plugin will add a section in Customize for control typography of your theme.
Version: 1.0
Author: Rinku Yadav
Author URI: http://rinkuyadav.com
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
Text Domain: easy-typography
Domain Path: /languages
*/

if( !class_exists( 'Kirki' ) )
{
	include_once( dirname( __FILE__ ) . '/includes/kirki/kirki.php' );
}

Kirki::add_config( 'easy_typography_config', array(
	'capability'    => 'manage_options',
	'option_type'   => 'option',
	'option_name'	=> 'easy_typography_options',
) );


add_filter( 'kirki/easy_typography_config/l10n', function( $l10n ) {

	$l10n['background-color']      = esc_attr__( 'Background Color', 'easy-typography' );
	$l10n['background-image']      = esc_attr__( 'Background Image', 'easy-typography' );
	$l10n['no-repeat']             = esc_attr__( 'No Repeat', 'easy-typography' );
	$l10n['repeat-all']            = esc_attr__( 'Repeat All', 'easy-typography' );
	$l10n['repeat-x']              = esc_attr__( 'Repeat Horizontally', 'easy-typography' );
	$l10n['repeat-y']              = esc_attr__( 'Repeat Vertically', 'easy-typography' );
	$l10n['inherit']               = esc_attr__( 'Inherit', 'easy-typography' );
	$l10n['background-repeat']     = esc_attr__( 'Background Repeat', 'easy-typography' );
	$l10n['cover']                 = esc_attr__( 'Cover', 'easy-typography' );
	$l10n['contain']               = esc_attr__( 'Contain', 'easy-typography' );
	$l10n['background-size']       = esc_attr__( 'Background Size', 'easy-typography' );
	$l10n['fixed']                 = esc_attr__( 'Fixed', 'easy-typography' );
	$l10n['scroll']                = esc_attr__( 'Scroll', 'easy-typography' );
	$l10n['background-attachment'] = esc_attr__( 'Background Attachment', 'easy-typography' );
	$l10n['left-top']              = esc_attr__( 'Left Top', 'easy-typography' );
	$l10n['left-center']           = esc_attr__( 'Left Center', 'easy-typography' );
	$l10n['left-bottom']           = esc_attr__( 'Left Bottom', 'easy-typography' );
	$l10n['right-top']             = esc_attr__( 'Right Top', 'easy-typography' );
	$l10n['right-center']          = esc_attr__( 'Right Center', 'easy-typography' );
	$l10n['right-bottom']          = esc_attr__( 'Right Bottom', 'easy-typography' );
	$l10n['center-top']            = esc_attr__( 'Center Top', 'easy-typography' );
	$l10n['center-center']         = esc_attr__( 'Center Center', 'easy-typography' );
	$l10n['center-bottom']         = esc_attr__( 'Center Bottom', 'easy-typography' );
	$l10n['background-position']   = esc_attr__( 'Background Position', 'easy-typography' );
	$l10n['background-opacity']    = esc_attr__( 'Background Opacity', 'easy-typography' );
	$l10n['on']                    = esc_attr__( 'ON', 'easy-typography' );
	$l10n['off']                   = esc_attr__( 'OFF', 'easy-typography' );
	$l10n['all']                   = esc_attr__( 'All', 'easy-typography' );
	$l10n['cyrillic']              = esc_attr__( 'Cyrillic', 'easy-typography' );
	$l10n['cyrillic-ext']          = esc_attr__( 'Cyrillic Extended', 'easy-typography' );
	$l10n['devanagari']            = esc_attr__( 'Devanagari', 'easy-typography' );
	$l10n['greek']                 = esc_attr__( 'Greek', 'easy-typography' );
	$l10n['greek-ext']             = esc_attr__( 'Greek Extended', 'easy-typography' );
	$l10n['khmer']                 = esc_attr__( 'Khmer', 'easy-typography' );
	$l10n['latin']                 = esc_attr__( 'Latin', 'easy-typography' );
	$l10n['latin-ext']             = esc_attr__( 'Latin Extended', 'easy-typography' );
	$l10n['vietnamese']            = esc_attr__( 'Vietnamese', 'easy-typography' );
	$l10n['hebrew']                = esc_attr__( 'Hebrew', 'easy-typography' );
	$l10n['arabic']                = esc_attr__( 'Arabic', 'easy-typography' );
	$l10n['bengali']               = esc_attr__( 'Bengali', 'easy-typography' );
	$l10n['gujarati']              = esc_attr__( 'Gujarati', 'easy-typography' );
	$l10n['tamil']                 = esc_attr__( 'Tamil', 'easy-typography' );
	$l10n['telugu']                = esc_attr__( 'Telugu', 'easy-typography' );
	$l10n['thai']                  = esc_attr__( 'Thai', 'easy-typography' );
	$l10n['serif']                 = _x( 'Serif', 'font style', 'easy-typography' );
	$l10n['sans-serif']            = _x( 'Sans Serif', 'font style', 'easy-typography' );
	$l10n['monospace']             = _x( 'Monospace', 'font style', 'easy-typography' );
	$l10n['font-family']           = esc_attr__( 'Font Family', 'easy-typography' );
	$l10n['font-size']             = esc_attr__( 'Font Size', 'easy-typography' );
	$l10n['font-weight']           = esc_attr__( 'Font Weight', 'easy-typography' );
	$l10n['line-height']           = esc_attr__( 'Line Height', 'easy-typography' );
	$l10n['font-style']            = esc_attr__( 'Font Style', 'easy-typography' );
	$l10n['letter-spacing']        = esc_attr__( 'Letter Spacing', 'easy-typography' );
	$l10n['top']                   = esc_attr__( 'Top', 'easy-typography' );
	$l10n['bottom']                = esc_attr__( 'Bottom', 'easy-typography' );
	$l10n['left']                  = esc_attr__( 'Left', 'easy-typography' );
	$l10n['right']                 = esc_attr__( 'Right', 'easy-typography' );
	$l10n['color']                 = esc_attr__( 'Color', 'easy-typography' );
	$l10n['add-image']             = esc_attr__( 'Add Image', 'easy-typography' );
	$l10n['change-image']          = esc_attr__( 'Change Image', 'easy-typography' );
	$l10n['remove']                = esc_attr__( 'Remove', 'easy-typography' );
	$l10n['no-image-selected']     = esc_attr__( 'No Image Selected', 'easy-typography' );
	$l10n['select-font-family']    = esc_attr__( 'Select a font-family', 'easy-typography' );
	$l10n['variant']               = esc_attr__( 'Variant', 'easy-typography' );
	$l10n['subsets']               = esc_attr__( 'Subset', 'easy-typography' );
	$l10n['size']                  = esc_attr__( 'Size', 'easy-typography' );
	$l10n['height']                = esc_attr__( 'Height', 'easy-typography' );
	$l10n['spacing']               = esc_attr__( 'Spacing', 'easy-typography' );
	$l10n['ultra-light']           = esc_attr__( 'Ultra-Light 100', 'easy-typography' );
	$l10n['ultra-light-italic']    = esc_attr__( 'Ultra-Light 100 Italic', 'easy-typography' );
	$l10n['light']                 = esc_attr__( 'Light 200', 'easy-typography' );
	$l10n['light-italic']          = esc_attr__( 'Light 200 Italic', 'easy-typography' );
	$l10n['book']                  = esc_attr__( 'Book 300', 'easy-typography' );
	$l10n['book-italic']           = esc_attr__( 'Book 300 Italic', 'easy-typography' );
	$l10n['regular']               = esc_attr__( 'Normal 400', 'easy-typography' );
	$l10n['italic']                = esc_attr__( 'Normal 400 Italic', 'easy-typography' );
	$l10n['medium']                = esc_attr__( 'Medium 500', 'easy-typography' );
	$l10n['medium-italic']         = esc_attr__( 'Medium 500 Italic', 'easy-typography' );
	$l10n['semi-bold']             = esc_attr__( 'Semi-Bold 600', 'easy-typography' );
	$l10n['semi-bold-italic']      = esc_attr__( 'Semi-Bold 600 Italic', 'easy-typography' );
	$l10n['bold']                  = esc_attr__( 'Bold 700', 'easy-typography' );
	$l10n['bold-italic']           = esc_attr__( 'Bold 700 Italic', 'easy-typography' );
	$l10n['extra-bold']            = esc_attr__( 'Extra-Bold 800', 'easy-typography' );
	$l10n['extra-bold-italic']     = esc_attr__( 'Extra-Bold 800 Italic', 'easy-typography' );
	$l10n['ultra-bold']            = esc_attr__( 'Ultra-Bold 900', 'easy-typography' );
	$l10n['ultra-bold-italic']     = esc_attr__( 'Ultra-Bold 900 Italic', 'easy-typography' );
	$l10n['invalid-value']         = esc_attr__( 'Invalid Value', 'easy-typography' );

	return $l10n;

} );

add_action( 'plugins_loaded', 'easy_typography_load_textdomain');
function easy_typography_load_textdomain()
{
	load_plugin_textdomain( 'easy-typography', false, basename( dirname( __FILE__ ) ) . '/languages/' );
}


/*
* Add Custom Shortcut Links to WordPress Toolbar
*/
if( !function_exists( 'easy_typography_toolbar_link' ) )
{
	function easy_typography_toolbar_link( $wp_admin_bar )
	{
		// Don't display menu in admin bar if current_user_can not manage_options
		if( !current_user_can( 'manage_options' ) )
		{
			return;
		}
		
		// Add main link 
		$args = array(
			'id' => 'easy_typography_toolbar_link_main',
			'title' => __( 'Typography Options', 'easy-typography' ),
			'href' => get_dashboard_url() . 'customize.php?autofocus[section]=easy_typography_main_section', 
		);
		$wp_admin_bar->add_node($args);
		
		// Add the first child link 
		$args = array(
			'id' => 'easy_typography_toolbar_link_donate',
			'title' => __( 'Donate to Developer', 'easy-typography' ),
			'href' => 'https://www.paypal.me/RinkuYadav',
			'parent' => 'easy_typography_toolbar_link_main', 
			'meta' => array(
				'target' => '_blank'
				)
		);
		$wp_admin_bar->add_node($args);
		
	}
}
add_action( 'admin_bar_menu', 'easy_typography_toolbar_link', 999 );

Kirki::add_section( 'easy_typography_main_section', array(
    'title'          => esc_attr__( 'Typography Options', 'easy-typography' ),
	'description'    => esc_attr__( 'Typography Options by Easy Typography Plugin', 'easy-typography' ) . ' <a href="https://www.paypal.me/RinkuYadav" target="_blank" >' . esc_attr__( 'Donate', 'easy-typography' ) . '</a>',
    'priority'       => 1,
    'capability'     => 'manage_options',
) );

Kirki::add_field( 'easy_typography_config', array(
	'type'        => 'typography',
	'settings'    => 'typography_body',
	'label'       => esc_attr__( 'Body Typography', 'easy-typography' ),
	'section'     => 'easy_typography_main_section',
	'default'     => array(
		'font-family'    => 'Roboto',
		'variant'        => 'regular',
		'font-size'      => '16px',
		'line-height'    => '1.5',
		'letter-spacing' => '0.1px',
		'subsets'        => array( 'latin-ext' ),
		'color'          => '#000000',
		'text-transform' => 'inherit',
		'text-align'     => 'inherit'
	),
	'priority'    => 10,
	'output'      => array(
		array(
			'element' => 'body',
		),
	),
	'transport' => 'auto',
) );

Kirki::add_field( 'easy_typography_config', array(
	'type'        => 'typography',
	'settings'    => 'typography_h1',
	'label'       => esc_attr__( 'Headline 1 H1 Typography', 'easy-typography' ),
	'section'     => 'easy_typography_main_section',
	'default'     => array(
		'font-family'    => 'Roboto',
		'variant'        => 'regular',
		'font-size'      => '26px',
		'line-height'    => '1.5',
		'letter-spacing' => '0.1px',
		'subsets'        => array( 'latin-ext' ),
		'color'          => '#000000',
		'text-transform' => 'inherit',
		'text-align'     => 'inherit'
	),
	'priority'    => 10,
	'output'      => array(
		array(
			'element' => 'h1, body h1, body h1 a, body h1.entry-title, body h1.entry-title a, body .entry-title h1, body .entry-title h1 a, body .entry-content h1, body .entry-content h1 a',
		),
	),
	'transport' => 'auto',
) );

Kirki::add_field( 'easy_typography_config', array(
	'type'        => 'typography',
	'settings'    => 'typography_h2',
	'label'       => esc_attr__( 'Headline 2 H2 Typography', 'easy-typography' ),
	'section'     => 'easy_typography_main_section',
	'default'     => array(
		'font-family'    => 'Roboto',
		'variant'        => 'regular',
		'font-size'      => '24px',
		'line-height'    => '1.5',
		'letter-spacing' => '0.1px',
		'subsets'        => array( 'latin-ext' ),
		'color'          => '#000000',
		'text-transform' => 'inherit',
		'text-align'     => 'inherit'
	),
	'priority'    => 10,
	'output'      => array(
		array(
			'element' => 'h2, body h2, body h2 a, body h2.entry-title, body h2.entry-title a, body .entry-title h2, body .entry-title h2 a, body .entry-content h2, body .entry-content h2 a',
		),
	),
	'transport' => 'auto',
) );


Kirki::add_field( 'easy_typography_config', array(
	'type'        => 'typography',
	'settings'    => 'typography_h3',
	'label'       => esc_attr__( 'Headline 3 H3 Typography', 'easy-typography' ),
	'section'     => 'easy_typography_main_section',
	'default'     => array(
		'font-family'    => 'Roboto',
		'variant'        => 'regular',
		'font-size'      => '22px',
		'line-height'    => '1.5',
		'letter-spacing' => '0.1px',
		'subsets'        => array( 'latin-ext' ),
		'color'          => '#000000',
		'text-transform' => 'inherit',
		'text-align'     => 'inherit'
	),
	'priority'    => 10,
	'output'      => array(
		array(
			'element' => 'h3, body h3, body h3 a, body h3.entry-title, body h3.entry-title a, body .entry-title h3, body .entry-title h3 a, body .entry-content h3, body .entry-content h3 a',
		),
	),
	'transport' => 'auto',
) );


Kirki::add_field( 'easy_typography_config', array(
	'type'        => 'typography',
	'settings'    => 'typography_h4',
	'label'       => esc_attr__( 'Headline 4 H4 Typography', 'easy-typography' ),
	'section'     => 'easy_typography_main_section',
	'default'     => array(
		'font-family'    => 'Roboto',
		'variant'        => 'regular',
		'font-size'      => '20px',
		'line-height'    => '1.5',
		'letter-spacing' => '0.1px',
		'subsets'        => array( 'latin-ext' ),
		'color'          => '#000000',
		'text-transform' => 'inherit',
		'text-align'     => 'inherit'
	),
	'priority'    => 10,
	'output'      => array(
		array(
			'element' => 'h4, body h4, body h4 a, body h4.entry-title, body h4.entry-title a, body .entry-title h4, body .entry-title h4 a, body .entry-content h4, body .entry-content h4 a',
		),
	),
	'transport' => 'auto',
) );

Kirki::add_field( 'easy_typography_config', array(
	'type'        => 'typography',
	'settings'    => 'typography_h5',
	'label'       => esc_attr__( 'Headline 5 H5 Typography', 'easy-typography' ),
	'section'     => 'easy_typography_main_section',
	'default'     => array(
		'font-family'    => 'Roboto',
		'variant'        => 'regular',
		'font-size'      => '18px',
		'line-height'    => '1.5',
		'letter-spacing' => '0.1px',
		'subsets'        => array( 'latin-ext' ),
		'color'          => '#000000',
		'text-transform' => 'inherit',
		'text-align'     => 'inherit'
	),
	'priority'    => 10,
	'output'      => array(
		array(
			'element' => 'h5, body h5, body h5 a, body h5.entry-title, body h5.entry-title a, body .entry-title h5, body .entry-title h5 a, body .entry-content h5, body .entry-content h5 a',
		),
	),
	'transport' => 'auto',
) );

Kirki::add_field( 'easy_typography_config', array(
	'type'        => 'typography',
	'settings'    => 'typography_h6',
	'label'       => esc_attr__( 'Headline 6 H6 Typography', 'easy-typography' ),
	'section'     => 'easy_typography_main_section',
	'default'     => array(
		'font-family'    => 'Roboto',
		'variant'        => 'regular',
		'font-size'      => '16px',
		'line-height'    => '1.5',
		'letter-spacing' => '0.1px',
		'subsets'        => array( 'latin-ext' ),
		'color'          => '#000000',
		'text-transform' => 'inherit',
		'text-align'     => 'inherit'
	),
	'priority'    => 10,
	'output'      => array(
		array(
			'element' => 'h6, body h6, body h6 a, body h6.entry-title, body h6.entry-title a, body .entry-title h6, body .entry-title h6 a, body .entry-content h6, body .entry-content h6 a',
		),
	),
	'transport' => 'auto',
) );

Kirki::add_field( 'easy_typography_config', array(
	'type'        => 'typography',
	'settings'    => 'typography_p',
	'label'       => esc_attr__( 'Paragraph Typography', 'easy-typography' ),
	'section'     => 'easy_typography_main_section',
	'default'     => array(
		'font-family'    => 'Roboto',
		'variant'        => 'regular',
		'font-size'      => '16px',
		'line-height'    => '1.5',
		'letter-spacing' => '0.1px',
		'subsets'        => array( 'latin-ext' ),
		'color'          => '#000000',
		'text-transform' => 'inherit',
		'text-align'     => 'inherit'
	),
	'priority'    => 10,
	'output'      => array(
		array(
			'element' => 'p, body p, body .entry-content p',
		),
	),
	'transport' => 'auto',
) );

Kirki::add_field( 'easy_typography_config', array(
	'type'        => 'typography',
	'settings'    => 'typography_ul_ol',
	'label'       => esc_attr__( 'Unorder Order List UL OL Typography', 'easy-typography' ),
	'section'     => 'easy_typography_main_section',
	'default'     => array(
		'font-family'    => 'Roboto',
		'variant'        => 'regular',
		'font-size'      => '16px',
		'line-height'    => '1.5',
		'letter-spacing' => '0.1px',
		'subsets'        => array( 'latin-ext' ),
		'color'          => '#000000',
		'text-transform' => 'inherit',
		'text-align'     => 'inherit'
	),
	'priority'    => 10,
	'output'      => array(
		array(
			'element' => 'body ul li, body ul li a, body ol li, body ol li a, body .entry-content ul li, body .entry-content ul li a, body .entry-content ol li, body .entry-content ol li a',
		),
	),
	'transport' => 'auto',
) );




